tenant:
  # secrets:
  #   existingSecret: minio-configuration
  tenant:
    # Tenant name
    name: minio
    configuration:
      name: minio-configuration
    configSecret:
      existingSecret: true
      name: myminio-env-configuration
      accessKey: ""
      secretKey: ""
    image:
      pullPolicy: Always
    ## Specification for MinIO Pool(s) in this Tenant.
    pools:
      ## Servers specifies the number of MinIO Tenant Pods / Servers in this pool.
      ## For standalone mode, supply 1. For distributed mode, supply 4 or more.
      ## Note that the operator does not support upgrading from standalone to distributed mode.
      - servers: 3
        ## custom name for the pool
        name: pool-0
        ## volumesPerServer specifies the number of volumes attached per MinIO Tenant Pod / Server.
        volumesPerServer: 4
        ## size specifies the capacity per volume
        size: 50Gi
        ## storageClass specifies the storage class name to be used for this pool
        storageClassName: ceph-block
        ## Used to specify annotations for pods
        annotations: { }
        ## Used to specify labels for pods
        labels: { }
        ## Used to specify a toleration for a pod
        tolerations: [ ]
        ## nodeSelector parameters for MinIO Pods. It specifies a map of key-value pairs. For the pod to be
        ## eligible to run on a node, the node must have each of the
        ## indicated key-value pairs as labels.
        ## Read more here: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/
        nodeSelector: { }
        ## Affinity settings for MinIO pods. Read more about affinity
        ## here: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/#affinity-and-anti-affinity.
        affinity: { }
        ## Configure resource requests and limits for MinIO containers
        resources: { }
        ## Configure security context
        securityContext: { }
        ## Configure topology constraints
        topologySpreadConstraints: [ ]
        ## Configure Runtime Class
        # runtimeClassName: ""
      # - servers: 3
      #   ## custom name for the pool
      #   name: pool-1
      #   ## volumesPerServer specifies the number of volumes attached per MinIO Tenant Pod / Server.
      #   volumesPerServer: 4
      #   ## size specifies the capacity per volume
      #   size: 50Gi
      #   ## storageClass specifies the storage class name to be used for this pool
      #   storageClassName: ceph-block
      #   ## Used to specify annotations for pods
      #   annotations: { }
      #   ## Used to specify labels for pods
      #   labels: { }
      #   ## Used to specify a toleration for a pod
      #   tolerations: [ ]
      #   ## nodeSelector parameters for MinIO Pods. It specifies a map of key-value pairs. For the pod to be
      #   ## eligible to run on a node, the node must have each of the
      #   ## indicated key-value pairs as labels.
      #   ## Read more here: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/
      #   nodeSelector: { }
      #   ## Affinity settings for MinIO pods. Read more about affinity
      #   ## here: https://kubernetes.io/docs/concepts/configuration/assign-pod-node/#affinity-and-anti-affinity.
      #   affinity: { }
      #   ## Configure resource requests and limits for MinIO containers
      #   resources: { }
      #   ## Configure security context
      #   securityContext: { }
      #   ## Configure topology constraints
      #   topologySpreadConstraints: [ ]
      #   ## Configure Runtime Class
      #   # runtimeClassName: ""
    ## Mount path where PV will be mounted inside container(s).
    mountPath: /export
    ## Sub path inside Mount path where MinIO stores data.
    subPath: /data
    # pool metrics to be read by Prometheus
    metrics:
      enabled: true
      port: 9000
      protocol: http
    certificate:
      ## Use this field to provide one or more external CA certificates. This is used by MinIO
      ## to verify TLS connections with other applications:
      ## https://github.com/minio/minio/tree/master/docs/tls/kubernetes#2-create-kubernetes-secret
      externalCaCertSecret: [ ]
      ## Use this field to provide a list of Secrets with external certificates. This can be used to configure
      ## TLS for MinIO Tenant pods. Create secrets as explained here:
      ## https://github.com/minio/minio/tree/master/docs/tls/kubernetes#2-create-kubernetes-secret
      externalCertSecret: [ ]
      ## Enable automatic Kubernetes based certificate generation and signing as explained in
      ## https://kubernetes.io/docs/tasks/tls/managing-tls-in-a-cluster
      requestAutoCert: true
      ## This field is used only when "requestAutoCert" is set to true. Use this field to set CommonName
      ## for the auto-generated certificate. Internal DNS name for the pod will be used if CommonName is
      ## not provided. DNS name format is *.minio.default.svc.cluster.local
      certConfig: { }
    ## MinIO features to enable or disable in the MinIO Tenant
    ## https://github.com/minio/operator/blob/master/docs/crd.adoc#features
    features:
      bucketDNS: false
      domains: 
        minio: 
          - https://minio.pineapplenest.com
          - https://minio-console.pineapplenest.com
        console: https://minio-console.pineapplenest.com
    ## List of bucket names to create during tenant provisioning
    buckets: [ ]
    ## List of secret names to use for generating MinIO users during tenant provisioning
    users: [ ]
    ## PodManagement policy for MinIO Tenant Pods. Can be "OrderedReady" or "Parallel"
    ## Refer https://kubernetes.io/docs/tutorials/stateful-application/basic-stateful-set/#pod-management-policy
    ## for details.
    podManagementPolicy: Parallel
    # Liveness Probe for container liveness. Container will be restarted if the probe fails.
    # Refer https://kubernetes.io/docs/tasks/configure-pod-container/configure-liveness-readiness-startup-probes.
    liveness: { }
    # Readiness Probe for container readiness. Container will be removed from service endpoints if the probe fails.
    # Refer https://kubernetes.io/docs/tasks/configure-pod-container/configure-liveness-readiness-startup-probes/
    readiness: { }
    ## exposeServices defines the exposure of the MinIO object storage and Console services.
    ## service is exposed as a loadbalancer in k8s service.
    exposeServices: { }
    # kubernetes service account associated with a specific tenant
    # https://kubernetes.io/docs/tasks/configure-pod-container/configure-service-account/
    serviceAccountName: ""
    # Tenant scrape configuration will be added to prometheus managed by the prometheus-operator.
    prometheusOperator: true
    # Enable JSON, Anonymous logging for MinIO tenants.
    # Refer https://github.com/minio/operator/blob/master/pkg/apis/minio.min.io/v2/types.go#L303
    # How logs will look:
    # $ k logs minio1-pool-0-0 -n default
    # {"level":"INFO","errKind":"","time":"2022-04-07T21:49:33.740058549Z","message":"All MinIO sub-systems initialized successfully"}
    # Notice they are in JSON format to be consumed
    logging:
      anonymous: false
      json: true
      quiet: false
    ## serviceMetadata allows passing additional labels and annotations to MinIO and Console specific
    ## services created by the operator.
    serviceMetadata: { }
    ## Add environment variables to be set in MinIO container (https://github.com/minio/minio/tree/master/docs/config)
    env:
      - name: MINIO_NOTIFY_WEBHOOK_ENABLE_EVENTS
        value: "on"
      - name: MINIO_NOTIFY_WEBHOOK_ENDPOINT_EVENTS
        value: "http://minio-webhook-util.minio-webhook-util/object"
      - name: MINIO_AUDIT_WEBHOOK_ENABLE_PRIMARY
        value: "on"
      - name: MINIO_AUDIT_WEBHOOK_ENDPOINT_PRIMARY
        value: "http://minio-webhook-util.minio-webhook-util/audit"
      - name: MINIO_IDENTITY_OPENID_CONFIG_URL_PRIMARY_IAM
        value: "https://keycloak.pineapplenest.com/realms/production/.well-known/openid-configuration"
      - name: MINIO_IDENTITY_OPENID_CLIENT_ID_PRIMARY_IAM
        value: "minio"
      - name: MINIO_IDENTITY_OPENID_CLIENT_SECRET_PRIMARY_IAM
        valueFrom:
          secretKeyRef:
            name: minio-oidc
            key: client-secret
      - name: MINIO_IDENTITY_OPENID_DISPLAY_NAME_PRIMARY_IAM
        value: "Keycloak"
      - name: MINIO_IDENTITY_OPENID_SCOPES_PRIMARY_IAM
        value: "openid,email,profile,groups"
      - name: MINIO_IDENTITY_OPENID_REDIRECT_URI_DYNAMIC_PRIMARY_IAM
        value: "on"
      - name: MINIO_PROMETHEUS_AUTH_TYPE
        value: "public"
    ## PriorityClassName indicates the Pod priority and hence importance of a Pod relative to other Pods.
    ## This is applied to MinIO pods only.
    ## Refer Kubernetes documentation for details https://kubernetes.io/docs/concepts/configuration/pod-priority-preemption/#priorityclass/
    priorityClassName: ""
    ## Define configuration for KES (stateless and distributed key-management system)
    ## Refer https://github.com/minio/kes
    #kes:
    #  image: "" # minio/kes:v0.18.0
    #  env: [ ]
    #  replicas: 2
    #  configuration: |-
    #    address: :7373
    #    root: _ # Effectively disabled since no root identity necessary.
    #    tls:
    #      key: /tmp/kes/server.key   # Path to the TLS private key
    #      cert: /tmp/kes/server.crt # Path to the TLS certificate
    #      proxy:
    #        identities: []
    #        header:
    #          cert: X-Tls-Client-Cert
    #    policy:
    #      my-policy:
    #        paths:
    #        - /v1/key/create/*
    #        - /v1/key/generate/*
    #        - /v1/key/decrypt/*
    #        identities:
    #        - ${MINIO_KES_IDENTITY}
    #    cache:
    #      expiry:
    #        any: 5m0s
    #        unused: 20s
    #    log:
    #      error: on
    #      audit: off
    #    keys:
    #      ## KES configured with fs (File System mode) doesnt work in Kubernetes environments and it's not recommended
    #      ## use a real KMS
    #      # fs:
    #      #   path: "./keys" # Path to directory. Keys will be stored as files. Not Recommended for Production.
    #      vault:
    #        endpoint: "http://vault.default.svc.cluster.local:8200" # The Vault endpoint
    #        namespace: "" # An optional Vault namespace. See: https://www.vaultproject.io/docs/enterprise/namespaces/index.html
    #        prefix: "my-minio"    # An optional K/V prefix. The server will store keys under this prefix.
    #        approle:    # AppRole credentials. See: https://www.vaultproject.io/docs/auth/approle.html
    #          id: "<YOUR APPROLE ID HERE>"      # Your AppRole Role ID
    #          secret: "<YOUR APPROLE SECRET ID HERE>"  # Your AppRole Secret ID
    #          retry: 15s  # Duration until the server tries to re-authenticate after connection loss.
    #        tls:        # The Vault client TLS configuration for mTLS authentication and certificate verification
    #          key: ""     # Path to the TLS client private key for mTLS authentication to Vault
    #          cert: ""    # Path to the TLS client certificate for mTLS authentication to Vault
    #          ca: ""      # Path to one or multiple PEM root CA certificates
    #        status:     # Vault status configuration. The server will periodically reach out to Vault to check its status.
    #          ping: 10s   # Duration until the server checks Vault's status again.
    #      # aws:
    #      #   # The AWS SecretsManager key store. The server will store
    #      #   # secret keys at the AWS SecretsManager encrypted with
    #      #   # AWS-KMS. See: https://aws.amazon.com/secrets-manager
    #      #   secretsmanager:
    #      #     endpoint: ""   # The AWS SecretsManager endpoint      - e.g.: secretsmanager.us-east-2.amazonaws.com
    #      #     region: ""     # The AWS region of the SecretsManager - e.g.: us-east-2
    #      #     kmskey: ""     # The AWS-KMS key ID used to en/decrypt secrets at the SecretsManager. By default (if not set) the default AWS-KMS key will be used.
    #      #     credentials:   # The AWS credentials for accessing secrets at the AWS SecretsManager.
    #      #       accesskey: ""  # Your AWS Access Key
    #      #       secretkey: ""  # Your AWS Secret Key
    #      #       token: ""      # Your AWS session token (usually optional)
    #  imagePullPolicy: "IfNotPresent"
    #  externalCertSecret: null
    #  clientCertSecret: null
    #  ## Key name to be created on the KMS, default is "my-minio-key"
    #  keyName: ""
    #  resources: { }
    #  nodeSelector: { }
    #  affinity:
    #    nodeAffinity: { }
    #    podAffinity: { }
    #    podAntiAffinity: { }
    #  tolerations: [ ]
    #  annotations: { }
    #  labels: { }
    #  serviceAccountName: ""
    #  securityContext:
    #    runAsUser: 1000
    #    runAsGroup: 1000
    #    runAsNonRoot: true
    #    fsGroup: 1000
    ## Prometheus setup for MinIO Tenant.
    prometheus:
      disabled: true
      image: "" # defaults to quay.io/prometheus/prometheus:latest
      env: [ ]
      sidecarimage: "" # defaults to alpine
      initimage: "" # defaults to busybox:1.33.1
      diskCapacityGB: false
      storageClassName: standard
      annotations: { }
      labels: { }
      nodeSelector: { }
      tolerations: [ ]
      affinity:
        nodeAffinity: { }
        podAffinity: { }
        podAntiAffinity: { }
      resources: { }
      serviceAccountName: ""
      securityContext:
        runAsUser: 1000
        runAsGroup: 1000
        runAsNonRoot: true
        fsGroup: 1000
    ## LogSearch API setup for MinIO Tenant.
    log:
      disabled: true
      image: "" # defaults to minio/operator:v4.4.17
      env: [ ]
      resources: { }
      nodeSelector: { }
      affinity:
        nodeAffinity: { }
        podAffinity: { }
        podAntiAffinity: { }
      tolerations: [ ]
      annotations: { }
      labels: { }
      audit:
        diskCapacityGB: false
      ## Postgres setup for LogSearch API
      db:
        image: "" # defaults to library/postgres
        env: [ ]
        initimage: "" # defaults to busybox:1.33.1
        volumeClaimTemplate:
          metadata: { }
          spec:
            storageClassName: standard
            accessModes:
              - ReadWriteOnce
            resources:
              requests:
                storage: false
        resources: { }
        nodeSelector: { }
        affinity:
          nodeAffinity: { }
          podAffinity: { }
          podAntiAffinity: { }
        tolerations: [ ]
        annotations: { }
        labels: { }
        serviceAccountName: ""
        securityContext:
          runAsUser: 999
          runAsGroup: 999
          runAsNonRoot: true
          fsGroup: 999
      serviceAccountName: ""
      securityContext:
        runAsUser: 1000
        runAsGroup: 1000
        runAsNonRoot: true
        fsGroup: 1000
  ingress:
    api:
      enabled: true
      ingressClassName: "nginx"
      annotations:
        cert-manager.io/cluster-issuer: le-cf-issuer
        nginx.ingress.kubernetes.io/backend-protocol:  "HTTPS"
      tls:
        - hosts:
          - minio.pineapplenest.com
          secretName: minio-api-tls
      host: minio.pineapplenest.com
      path: /
      pathType: Prefix
    console:
      enabled: true
      ingressClassName: "nginx"
      annotations:
        cert-manager.io/cluster-issuer: le-cf-issuer
        nginx.ingress.kubernetes.io/backend-protocol:  "HTTPS"
      tls:
        - hosts:
          - minio-console.pineapplenest.com
          secretName: minio-console-tls
      host: minio-console.pineapplenest.com
      path: /
      pathType: Prefix
